let homeNative = null; //首页环境 1:h5 2:小程序 3:头条
let miniApp = null;
let toPageFun = null;
let Vue,
  createdUserJWT,
  getBcakUrl,
  shopConfig,
  shopMixid,
  Toast,
  hylToLink,
  requireFun,
  wx,
  extend,
  miniVersion = 999999;
// 登录白名单 name
const noLoginList = [
  "index",
  "media-video",
  "goods-goodsInfo",
  "goods-commodityMenu",
  "goodsSearch-goodsSearch",
  "contentSearch-contentSearch",
  "chooseStores",
  "activty-receivingGift",
  "activty",
  "login-register",
  "login-phoneLogin",
  "login-authInformation",
  "login-forgetPassWord",
  "login-accountLogin",
  "login-wxRegister",
  "pay-payList",
  "comment-evaluateList",
  "goods-commonProblemList",
  "article-articlePage",
  "article-articleList",
  "goods-posters",
  "liveBroadcast",
  "liveBroadcast-list",
  "personalCenter-coupon-getCoupon",
  "buyerShow-showDetail",
  "goods-addGoodsList",
  "personalCenter-CDkey-exchange",
  "giftCards-linkReceive",
  "giftCoupon-preview",
  "smartForm",
  "shopCart-shareShopCart",
  "groupBuying-beInvite",
  "brandTopics",
  "personalCenter-spokesmanCenter",
  "personalCenter-spokesmanCenter-mine-spokesmanHomePage",
  "liveBroadcast-lived",
  "personalCenter-spokesmanCenter-mine-getBusinessCard",
  "changeAdr",
  "enterpriseCustomerRegistration",
  "merchantsDetail"
];

// 函数柯里化
/**
 * @pageUrl pageUrlVal:跳转链接
 */
// 调用方法使用.call
function toPage() {
  console.log("toPage-------------");
  if (homeNative == 1) {
    return function({ pagePath, pageType = 1 }) {
      if (pageType == 1) {
        this.$router.push(pagePath);
      } else if (pageType == 2) {
        window.location.href = pagePath;
      } else if (pageType == 3) {
        wx.navigateTo({ url: pagePath }); // 指定页面的url
      }
    };
  } else if (homeNative == 2) {
    return function({ pagePath, pageType = 1 }) {
      if (pageType == 1) {
        console.log('pagePath',pagePath);
        wx.navigateTo({ url: pagePath });
      } else if (pageType == 2) {
        wx.reLaunch({ url: pagePath });
      }
    };
  }
}
function toPageUrl(backPath, backParams = "") {
  return `../index/main?from=themeLink&backpath=${encodeURIComponent(
    backPath
  )}&params=${encodeURIComponent(backParams)}`;
}
function getSessionId() {
  if (homeNative == 1) {
    return (
      this.$store && this.$store.state.sessionId && this.$store.state.sessionId
    );
  } else if (homeNative == 2) {
    return wx && wx.getStorageSync("sessionid");
  }
}
function getIsMini() {
  return homeNative == 1 && this.$store && this.$store.state.miniProgram;
}
function getUserInfo() {
  if (homeNative == 1) {
    return this.$store && this.$store.state.userInfo;
  } else if (homeNative == 2) {
    console.log(
      wx.getStorageSync("userInfo"),
      '---wx.getStorageSync("userInfo")'
    );
    return (
      wx &&
      wx.getStorageSync("userInfo") &&
      JSON.parse(wx.getStorageSync("userInfo"))
    );
  }
}
//商家中心外链(小程序使用 /pages/wxArticle/main?link 这个方法跳转)
function getGUIDE_URL() {
  if (homeNative == 1) {
    return shopConfig.GUIDE_URL;
  } else if (homeNative == 2) {
    return config.GUIDE_URL;
  }
}
// 分享
function toShare(data) {
  if (homeNative == 1) {
    this.$nuxt.$SHARE({ itemList: data.feature.value });
  } else if (homeNative == 2) {
    miniApp.shareInit({ itemList: data.feature.value });
  }
}
// 获取link 中页面地址(link兼容 有object或者string)
function getUrlofLink(data) {
  return data.link?data.link.split("?")[0] : "";
}
function getUrlofQuery(data) {
  let arr = data.link.split("?")
  let params = [];
  arr.forEach((res,index)=>{
    if(index>=1) {
        params.push(res)
    }
  })
  return params.join("?") || "";
}
// check 链接是否为底部导航栏页面 返回索引
function checkTabbarPage(link) {
  let app = getApp();
  if (!app.globalData.footerVal) return -1;
  let footerVal = app.globalData.footerVal.componentData.list;
  let isFooter = footerVal.findIndex(item => {
    return getUrlofLink(item.link) == link.split("?")[0];
  });
  return isFooter;
}
const noLoginListPath = noLoginList.map(item => {
  item = item.replace(/-/g, "/");
  item = "/" + item;
  item == "/index" && (item = "/");
  return item;
});
export function themeToLinkInit({
  homeNative: shop_env,
  wx: wxName,
  getCoupon,
  themeMemberCardClick,
  themeScanningCodeClick,
  requireFun: requireFun2,
  extend : extend2
}) {
  extend = extend2
  homeNative = shop_env;
  requireFun = requireFun2;
  console.log(requireFun, "-------------------------115");
  createdUserJWT = requireFun.createdUserJWT;
  getBcakUrl = requireFun.getBcakUrl;
  wx = wxName;
  if (wx) {
    // 获取小程序版本号
    let accountInfo = wx.getAccountInfoSync && wx.getAccountInfoSync();
    if (accountInfo) {
      miniVersion = accountInfo.miniProgram.version || 999999; // 1.0.0 小程序版本号
    }
  }
  console.log(miniVersion,'---------------miniVersion')
  console.log(homeNative, "-------------themeToLinkInit");
  toPageFun = toPage(homeNative);
  if (homeNative == 1) {
    try {
      Vue = requireFun.Vue;
      shopConfig = requireFun.shopConfig;
      shopMixid = requireFun.shopMixid;
      Vue.prototype.$themeToLink = $themeToLink;
      Toast = requireFun.Toast;
      hylToLink = requireFun.hylToLink;
    } catch (error) {}
  } else if (homeNative == 2) {
    miniApp = getApp();
    miniApp.$themeToLink = $themeToLink;
    miniApp.getCoupon = getCoupon;
    miniApp.themeMemberCardClick = themeMemberCardClick;
    miniApp.themeScanningCodeClick = themeScanningCodeClick;
  }
}
function parseQueryString(url) {
  let str = url.split("?")[1]
  if(!str){
    return {}
  }
  let items = str.split("&");
  let arr, name, value;
  let obj={}

  for (var i = 0; i < items.length; i++) {
    let spliceIndex = items[i].indexOf("=");
    // arr = items[i].split("=");    //["key0", "0"]
    name = items[i].slice(0,spliceIndex);
    value = items[i].slice(spliceIndex + 1);
    console.log(81, this)
    obj[name]=value
  }
  console.log(obj,'-------------obj')
  return obj
}
function loginInterception(data) {
  // 登录拦截
  let parseLink = getUrlofLink(data);
  let parseQuery = getUrlofQuery(data);
  let noLogin =
    noLoginListPath.includes(parseLink) ||
    parseLink.substr(0, 7) == "/goods/" ||
    parseLink.includes("/brandTopics") ||
    parseLink.startsWith('/activty/') ||
    parseLink.includes('dk.taokor.cn') || // 道可
    parseLink.includes('uat-zanmall-m.cipmp.com') ||  // 五粮液uat
    parseLink.includes('swt.wuliangye.com.cn'); // 五粮液prod
  if (!noLogin && !getSessionId.call(this)) {
    let url = ''
    if(parseQuery.indexOf('scene=sso')>-1) {
        url =  `/pages/login/main?back=${parseLink}&ossLink=${encodeURIComponent(parseQuery)}`;
    } else {
      console.log(encodeURIComponent(JSON.stringify(parseQueryString(data.link))),'------------------------JSON.stringify(parseQueryString(data.link))')
        url =  `/pages/login/main?back=${parseLink}&params=${encodeURIComponent(JSON.stringify(parseQueryString(data.link)))}`;
    }
    console.log(url,'------------------------190')
    toPageFun({ pagePath: url});
    return false;
  }
  //判断是否市跳转到tabbar页面 替换首页位置
  let isTabbarIndex = checkTabbarPage(parseLink);
  /**
   * 如果是点击底部导航或者底部导航有自定义页面且点击的为底部导航设置的自定义页面有tabClick这个参数(不是页面设置的自定义页面链接没有)
   * 以此来区分
   */
  console.log(data.link, '------------data.link')
  if (isTabbarIndex >= 0 || ((data.link.includes("/activty/") && data.link.includes("tabClick")))) {
    console.log('底部栏')
    // 无底部栏h5页面
    // if (!containFooterPage.includes(parseLink)) {
    //     toPage(getUrlofLink(data), getUrlofQuery(data))
    //     return
    // }

    isTabbarIndex = isTabbarIndex == 0 ? checkTabbarPage("/") : isTabbarIndex;
    let url =
      parseLink == "/"
        ? `/pages/home/main`
        : `/pages/tabBar${isTabbarIndex}/main`;
    let routes = getCurrentPages();
    let currentPage = routes[routes.length - 1].route;
    if (currentPage == url) return;
    let query = parseQuery ? `?${parseQuery}` : "";
    console.log(url,query,parseQuery, '--------------247')
    toPageFun({ pagePath: url + query, pageType: 2 });
    return false;
  }
  return true;
}

export async function $themeToLink(data) {
  console.log(data, "$themeToLink");

  console.log(extend,'extend=======')

  console.log('data',data);


  if (data.type == 0) {
    console.log("无链接--return")
    return;
  }
  // 第三方嵌入系统
  let type = data.type;
  if (type) {
    if(extend.loginIntercept && !getSessionId.call(this)){
      console.log('走进来了')
      let url = `/pages/login/main?back=${getUrlofLink(data)}&params=${JSON.stringify(parseQueryString(data.link))}`;
      
      toPageFun({ pagePath: url});
      return false
    }
    // if (data.link && data.link.includes("scene=sso")) {
    //   //?token=${token}&scene=sso
    //   if (!getSessionId.call(this)) {
    //     Toast("请先登录");
    //     return;
    //   }
    //   let { mobilephone: phoneNumber, email } = getUserInfo.call(
    //     this,
    //     homeNative
    //   );
    //   data.link = await getBcakUrl({
    //     toAppid: "hgFTLLhgnBmeOyCkcbyv",
    //     callbackUrl: data.link,
    //     phoneNumber,
    //     email
    //   });
    // }
    if (data.link && data.link.includes("dynamicForm")) {
      if (!getSessionId.call(this)) {
        console.log('走进来了--dynamicForm')
        let url = `/pages/login/main?back=${getUrlofLink(data)}&params=${JSON.stringify(parseQueryString(data.link))}`;
        toPageFun({ pagePath: url});
        return false
      } else {
        await createdUserJWT().then(res => {
          data.link += `&token=${res}`;
        }).catch(err => {
          
        });
      }
    }
  }

  //商城跳转到嗨有料首页
  if (homeNative == 1 && this.$store.getters["sceneModule/flushbonadingVisible"]) {
    hylToLink.call(this, {
      data,
      Vue: requireFun.Vue,
      Dialog: requireFun.Dialog,
      Toast: requireFun.Toast,
      hyl: requireFun.hyl,
      dateFilter: requireFun.dateFilter,
      shopConfig: requireFun.shopConfig
    });
    return;
  }
  console.log(data.key,'----------------------key')
    if (type != 2 && homeNative == 2 && !(data.key && data.key.startsWith("1.9")) && !(data.link.startsWith('/article/'))) {
      let loginInterceptionVal = loginInterception(data);
      if (!loginInterceptionVal) {
        return;
      }
    }
  ////向后兼容  兼容老数据
  if (type == undefined || type == "undefined") {
    if (data.length > 0) {
      if (homeNative == 1) {
        toPageFun.call(this, { pagePath: data });
      } else if (homeNative == 2) {
        let url = toPageUrl(getUrlofLink(data), getUrlofQuery(data));
        toPageFun({ pagePath: url });
      }
    }
    return;
  }
  console.log('---------跳过登录判断')
  //----
  if (type == 1) {
    //h5页面

    //兼容
    if (data.link.substring(0, 1) == "/") {
      // 跳转类型 targetType 0 push  1 replace
      // if (data.targetType && data.targetType == 1) {
      //   this.$nuxt.$router.push({
      //     path: data.link,
      //   });
      // } else {
      //   this.$nuxt.$router.push(data.link);
      // }

      // 文章页面跳转 小程序环境(getIsMini.call(this) == 1)都跳转到小程序页面
      // web环境下(h5，webview)跳转到h5页面
      if (data.link && (data.link.startsWith('/personalCenter/userInfo'))) {
        console.log(getIsMini.call(this) == 1, homeNative == 2,'------getIsMini.call(this) == 1 || homeNative == 2')
        if ((getIsMini.call(this) == 1 || homeNative == 2)) {
          let url = `/pages/userInfo/main`
          console.log('url',url);
          toPageFun({ pagePath: url, pageType: homeNative == 2?1:3 });
        } else {
          toPageFun.call(this, { pagePath: data.link });
        }
      } else if (data.link && (data.link.startsWith('/pay/paySuccess'))) {
        console.log(getIsMini.call(this) == 1, homeNative == 2,'------getIsMini.call(this) == 1 || homeNative == 2')
        // 判断小程序版本号
        console.log(miniVersion,'--miniVersion')
        if ((getIsMini.call(this) == 1 || homeNative == 2) && miniVersion > 284) {
          let url = `/pages/paySuccess/main?${data.link.split('?')[1]}`
          console.log('url',url);
          toPageFun({ pagePath: url, pageType: homeNative == 2?2:3 });
        } else {
          toPageFun.call(this, { pagePath: data.link });
        }
      } else if (data.link && (data.link.startsWith('/personalCenter/vip/vipMobileCard'))) {
        console.log(getIsMini.call(this) == 1, homeNative == 2,'------getIsMini.call(this) == 1 || homeNative == 2')
        if (getIsMini.call(this) == 1 || homeNative == 2) {
          let url = `/pages/memberCode/main`
          console.log('url',url);
          toPageFun({ pagePath: url, pageType: homeNative == 2?1:3 });
        } else {
          toPageFun.call(this, { pagePath: data.link });
        }
      } else if (data.link && (data.link.startsWith('/article/') && !data.link.startsWith('/article/articleList'))) {
        console.log(data.link && (data.link.startsWith('/article/') && !data.link.startsWith('/article/articleList')),data.link,homeNative,'--data.link')
        console.log(getIsMini.call(this) == 1, homeNative == 2,'------getIsMini.call(this) == 1 || homeNative == 2')
        if (getIsMini.call(this) == 1 || homeNative == 2) {
          let idList = data.link.split('/')
          let id = idList[idList.length - 1]
          let url = `/pages/pages_subpack/article/main?article_id=${id}`
          console.log('url',url);
          toPageFun({ pagePath: url, pageType: homeNative == 2?1:3 });
        } else {
          toPageFun.call(this, { pagePath: data.link });
        }
      } else if (homeNative == 1) {
        toPageFun.call(this, { pagePath: data.link });
      } else if (homeNative == 2) {
        let url = toPageUrl(getUrlofLink(data), getUrlofQuery(data));
        console.log('url',url);
        toPageFun({ pagePath: url});
      }
    } else {
      if (data.link.startsWith("http") || data.link.startsWith("https")) {
        if (homeNative == 1) {
          toPageFun.call(this, { pagePath: data.link, pageType: 2 });
        } else {
          let url =
            "/pages/wxArticle/main?link=" + encodeURIComponent(data.link);
          toPageFun({ pagePath: url });
        }
      } else {
        toPageFun({ pagePath: data.link, pageType: 2 });
      }
    }
  } else if (type == 1.1) {
    //小程序页面  可能增加登录态拦截
    if (homeNative == 2) {
      toPageFun({ pagePath: data.link });
    } else if (homeNative == 1) {
      if (
        getIsMini.call(this) == 1 ||
        getIsMini.call(this) == 2
      ) {
        toPageFun.call(this, { pagePath: data.link, pageType: 3 });
      } else {
        Toast("暂不支持");
      }
    }
  } else if (type == 1.2) {
    //第三方链接
    if (data.link == "outerChain:businessCenter") {
      // 进入商家中心外链
      console.log(getGUIDE_URL(), "-----getGUIDE_URL()");
      let url = `${getGUIDE_URL()}/login?mixid=${this.$nuxt.$route.query
        .mixid}&back=${encodeURIComponent(window.location.href)}`;
      toPageFun.call(this, { pagePath: url, pageType: 2 });
      return;
    }
    if (data.link.substring(0, 1) == "/") {
      toPageFun.call(this, { pagePath: data.link });
    } else {
      if (homeNative == 1) {
        if (
          this.$store.state.miniProgram == 1 ||
          this.$store.state.miniProgram == 2
        ) {
          let url =
            "/pages/wxArticle/main?link=" + encodeURIComponent(data.link);
          toPageFun.call(this, { pagePath: url, pageType: 3 });
        } else {
          toPageFun.call(this, { pagePath: data.link, pageType: 2 });
        }
      } else if (homeNative == 2) {
        let url = "/pages/wxArticle/main?link=" + encodeURIComponent(data.link);
        toPageFun.call(this, { pagePath: url, pageType: 1 });
      }
    }
  } else if (type == 2) {
    //功能
    let featureType = data.feature.type;
    if (featureType == "themeCouponClick" || featureType == 0) {
      //优惠券
      if (homeNative == 1) {
        this.$themeCouponClick(
          data.feature.value.couponCode,
          data.feature.value
        );
      } else if (homeNative == 2) {
        miniApp.getCoupon(data.feature.value.couponCode, data.feature.value);
      }
    } else if (featureType == 1) {
      //分享
      if (data.type == 2 && data.feature.type == 1) {
        //分享
        toShare.call(this, data);
      }
      // if (cb) {
      //   cb();
      // }
    } else if (featureType == "themeMemberCardClick" || featureType == 2) {
      //会员卡
      if (homeNative == 1) {
        this.$themeMemberCardClick(data.feature.value);
      } else if (homeNative == 2) {
        miniApp.themeMemberCardClick(data.feature.value);
      }
    } else if (featureType == 3) {
      // 扫码
      if (homeNative == 1) {
        this.$themeScanningCodeClick();
      } else if (homeNative == 2) {
        miniApp.themeScanningCodeClick();
      }
    }
  } else if (type == 3) {
    //小程序跳转到小程序
    console.log(homeNative,'-----------------homeNative')
    if (homeNative == 1) {
      if (
        getIsMini.call(this) == 1 ||
        getIsMini.call(this) == 2
      ) {
        if (this.$store.getters["sceneModule/flushbonadingVisible"]) {
          let url = `/pages/toMini/toMini?weappPage=${encodeURIComponent(
            data.link
          )}&weappAppId=${data.name}`;
          toPageFun.call(this, { pagePath: url, pageType: 3 });
          return;
        }
        let url2 = `/pages/toMini/main?weappPage=${encodeURIComponent(
          data.link
        )}&weappAppId=${data.name}`;
        toPageFun.call(this, { pagePath: url2, pageType: 3 });
      } else {
        Toast("暂不支持");
      }
    } else {
      if (data.key && data.key.startsWith("1.9")) {
        openChannelsActivity.call(this, data)
        return
      }
      let url2 = `/pages/toMini/main?weappPage=${encodeURIComponent(
        data.link
      )}&weappAppId=${data.name}`;
      toPageFun({ pagePath: url2 });
    }
  } else {
    //向后兼容
    if (data.length > 0) {
      toPageFun.call(this, { pagePath: data.link });
    }
  }
}

//小程序跳转视频号
function openChannelsActivity(data) {
  console.log('sss', data);
  if (homeNative == 2) {
    switch (data.key) {
      // 跳转视频号
      case '1.9.1':
        console.log('begin');
        if (wx.openChannelsActivity) {
          wx.openChannelsActivity({
            finderUserName: data.name,
            feedId: data.link,
            success:function(){
              console.log('success');
            },
            fail: function () {
              console.log('fail');
              wxModel.call(this,'提示','打开视频号失败')
            }
          })
        } else {
          wxModel.call(this)
        }
        console.log('end');
        break;
      // 跳转视频号活动页
      case '1.9.2':
        console.log('begin');
        if (wx.openChannelsEvent) {
          wx.openChannelsEvent({
            finderUserName: data.name, eventId: data.link, fail: function () {
              wxModel.call(this,'提示','打开视频号活动失败')
            }
          })
        } else {
          wxModel.call(this)
        }
        console.log('end');
        break
      default:
        break;
    }
  }
}

// 版本号兼容提示
function wxModel(title = '提示', content = '当前微信版本过低，无法使用该功能，请升级到最新微信版本后重试。') {
  wx.showModal({
    title: title,
    content: content
  })
  console.log('不支持');
}

global.themeToLinkInit = themeToLinkInit;
